unit l2daemonUnit;

{$mode objfpc}{$H+}

interface

uses
   Classes, SysUtils, FileUtil, ZConnection, IdTCPServer, DaemonApp, IdCustomTCPServer, IdContext;

type

   { TAppThread }

   TAppThread = class(TThread)
      Procedure Execute; override;
   End;


   { TL2Daemon }

   TL2Daemon = class(TDaemon)
      TCPServer: TIdTCPServer;
      procedure DataModuleStart(Sender: TCustomDaemon; var OK: Boolean);
      procedure DataModuleStop(Sender: TCustomDaemon; var OK: Boolean);
      procedure TCPServerExecute(AContext: TIdContext);
   private
      FThread : TAppThread;
      Procedure ThreadStopped (Sender : TObject);
   public
      Function Start : Boolean; override;
      Function Stop : Boolean; override;
   end;

var
   L2Daemon: TL2Daemon;

implementation

Uses Dialogs;

procedure RegisterDaemon;
begin
   RegisterDaemonClass(TL2Daemon)
end;

{$R *.frm}

{ TAppThread }

procedure TAppThread.Execute;
Var C : Integer;
begin
   C:=0;
   Repeat
      Sleep(10000);
      inc(c);
   //Application.Logger.Info(Format('Tick : %d',[C]));
      ShowMessage(Format('Tick : %d',[C]));
   Until Terminated;
end;

{ TL2Daemon }

procedure TL2Daemon.TCPServerExecute(AContext: TIdContext);
var
  sCommand: String;
  TIdTextEncoding:string;
begin

   //TIdNotify.NotifyMethod(ShowStartServerdMessage);
   sCommand := UpperCase(Trim((AContext.Connection.IOHandler.ReadLn(TIdTextEncoding))));

   Case sCommand of
      'PINGDMN': AContext.Connection.IOHandler.WriteLn('PINGDMN: OK');
      else
        AContext.Connection.IOHandler.WriteLn(sCommand);
   end;

   ShowMessage(sCommand);//fLog.Add(sCommand);

  //AContext.Connection.IOHandler.WriteLn('OK');
  //TIdNotify.NotifyMethod(StopStartServerdMessage);
end;

procedure TL2Daemon.ThreadStopped(Sender: TObject);
begin
   //
end;

function TL2Daemon.Start: Boolean;
begin
   Result:=inherited Start;
   ShowMessage('Start' + Result.ToString());
   FThread:=TAppThread.Create(True);
   FThread.OnTerminate:=@ThreadStopped;
   FThread.FreeOnTerminate:=False;
   FThread.Resume;
end;

function TL2Daemon.Stop: Boolean;
begin
   Result:=inherited Stop;
   ShowMessage('Stop' + Result.ToString());
   FThread.Terminate;
end;

procedure TL2Daemon.DataModuleStart(Sender: TCustomDaemon; var OK: Boolean);
begin
   OK := Start;
end;

procedure TL2Daemon.DataModuleStop(Sender: TCustomDaemon; var OK: Boolean);
begin
   OK := Stop;
end;


initialization
   RegisterDaemon;
end.

